//
//      Copyright, 2012-2019 (c)  Richard Gorton, All Rights Reserved
//
//      Author: Rick Gorton     rcgorton@verizon.net
//
// general utilities for C++ specific quirks, including STL.
//

#ifndef _UTIL_H_
#define _UTIL_H_ 1

#include <iostream>
#include <ostream>
#include <fstream>
#include <sstream>
#include <string>

/// Hacks to work around inability of streams to be able to do things like
///     string << int-type

// fixed by C++11 std::to_string()
// but ubuntu 18.04 does not seem to have this
template<typename T>
inline static std::string ToString( T val )
{
#if 1
   std::ostringstream ss;
   ss << val;
   return ss.str();
#else
    return std::to_string(val);
#endif
}


template<typename T>
inline static T StringTo( std::string str )
{
   T val;
   std::istringstream ss( str );
   ss >> val;
   return val;
}

#endif  // _UTIL_H_
